Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/app/init/init.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -50,9 +50,4 @@
 #include "init.h"
 
-#define DEVFS_MOUNT_POINT  "/dev"
-
-#define SRV_CONSOLE  "/srv/console"
-#define APP_GETTERM  "/app/getterm"
-
 static void info_print(void)
 {
@@ -63,5 +58,5 @@
 {
 	char *opts = "";
-	const char *root_dev = "bd/initrd";
+	const char *root_dev = "initrd";
 	
 	if (str_cmp(fstype, "tmpfs") == 0)
@@ -102,6 +97,6 @@
 	}
 	
-	snprintf(null, MAX_DEVICE_NAME, "null/%d", null_id);
-	int rc = mount("devfs", DEVFS_MOUNT_POINT, null, "", IPC_FLAG_BLOCKING);
+	snprintf(null, MAX_DEVICE_NAME, "null%d", null_id);
+	int rc = mount("devfs", "/dev", null, "", IPC_FLAG_BLOCKING);
 	
 	switch (rc) {
@@ -175,5 +170,5 @@
 	}
 
-	if ((texit != TASK_EXIT_NORMAL) || (retval != 0)) {
+	if (texit != TASK_EXIT_NORMAL || retval != 0) {
 		printf(NAME ": Server %s failed to start (returned %d)\n",
 			fname, retval);
@@ -181,54 +176,28 @@
 }
 
-static void console(char *dev)
-{
-	char *argv[3];
-	char hid_in[MAX_DEVICE_NAME];
+static void getvc(char *dev, char *app)
+{
+	char *argv[4];
+	char vc[MAX_DEVICE_NAME];
 	int rc;
 	
-	snprintf(hid_in, MAX_DEVICE_NAME, "%s/%s", DEVFS_MOUNT_POINT, dev);
-	
-	printf(NAME ": Spawning %s with %s\n", SRV_CONSOLE, hid_in);
-	
-	/* Wait for the input device to be ready */
+	snprintf(vc, MAX_DEVICE_NAME, "/dev/%s", dev);
+	
+	printf(NAME ": Spawning getvc on %s\n", vc);
+	
 	dev_handle_t handle;
 	rc = devmap_device_get_handle(dev, &handle, IPC_FLAG_BLOCKING);
 	
 	if (rc == EOK) {
-		argv[0] = SRV_CONSOLE;
-		argv[1] = hid_in;
-		argv[2] = NULL;
-		
-		if (!task_spawn(SRV_CONSOLE, argv))
-			printf(NAME ": Error spawning %s with %s\n", SRV_CONSOLE, hid_in);
-	} else
-		printf(NAME ": Error waiting on %s\n", hid_in);
-}
-
-static void getterm(char *dev, char *app)
-{
-	char *argv[4];
-	char term[MAX_DEVICE_NAME];
-	int rc;
-	
-	snprintf(term, MAX_DEVICE_NAME, "%s/%s", DEVFS_MOUNT_POINT, dev);
-	
-	printf(NAME ": Spawning %s with %s %s\n", APP_GETTERM, term, app);
-	
-	/* Wait for the terminal device to be ready */
-	dev_handle_t handle;
-	rc = devmap_device_get_handle(dev, &handle, IPC_FLAG_BLOCKING);
-	
-	if (rc == EOK) {
-		argv[0] = APP_GETTERM;
-		argv[1] = term;
+		argv[0] = "/app/getvc";
+		argv[1] = vc;
 		argv[2] = app;
 		argv[3] = NULL;
 		
-		if (!task_spawn(APP_GETTERM, argv))
-			printf(NAME ": Error spawning %s with %s %s\n", APP_GETTERM,
-			    term, app);
-	} else
-		printf(NAME ": Error waiting on %s\n", term);
+		if (!task_spawn("/app/getvc", argv))
+			printf(NAME ": Error spawning getvc on %s\n", vc);
+	} else {
+		printf(NAME ": Error waiting on %s\n", vc);
+	}
 }
 
@@ -237,8 +206,8 @@
 	int rc;
 
-	printf("Trying to mount bd/disk0 on /data... ");
+	printf("Trying to mount disk0 on /data... ");
 	fflush(stdout);
 
-	rc = mount("fat", "/data", "bd/disk0", "wtcache", 0);
+	rc = mount("fat", "/data", "disk0", "wtcache", 0);
 	if (rc == EOK)
 		printf("OK\n");
@@ -265,7 +234,5 @@
 	spawn("/srv/fb");
 	spawn("/srv/kbd");
-	console("hid_in/kbd");
-	
-	spawn("/srv/clip");
+	spawn("/srv/console");
 	spawn("/srv/fhc");
 	spawn("/srv/obio");
@@ -288,11 +255,11 @@
 #endif
 
-	getterm("term/vc0", "/app/bdsh");
-	getterm("term/vc1", "/app/bdsh");
-	getterm("term/vc2", "/app/bdsh");
-	getterm("term/vc3", "/app/bdsh");
-	getterm("term/vc4", "/app/bdsh");
-	getterm("term/vc5", "/app/bdsh");
-	getterm("term/vc6", "/app/klog");
+	getvc("vc0", "/app/bdsh");
+	getvc("vc1", "/app/bdsh");
+	getvc("vc2", "/app/bdsh");
+	getvc("vc3", "/app/bdsh");
+	getvc("vc4", "/app/bdsh");
+	getvc("vc5", "/app/bdsh");
+	getvc("vc6", "/app/klog");
 	
 	return 0;
Index: uspace/app/tester/vfs/vfs1.c
===================================================================
--- uspace/app/tester/vfs/vfs1.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/app/tester/vfs/vfs1.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -85,5 +85,5 @@
 		return "Unable to create null device";
 	
-	snprintf(null, MAX_DEVICE_NAME, "null/%d", null_id);
+	snprintf(null, MAX_DEVICE_NAME, "null%d", null_id);
 	int rc = mount(FS_TYPE, MOUNT_POINT, null, OPTIONS, FLAGS);
 	switch (rc) {
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/app/trace/trace.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -48,5 +48,5 @@
 #include <io/console.h>
 #include <io/keycode.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 
 #include <libc.h>
Index: uspace/lib/libblock/libblock.c
===================================================================
--- uspace/lib/libblock/libblock.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libblock/libblock.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -47,5 +47,5 @@
 #include <as.h>
 #include <assert.h>
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/list.h>
 #include <adt/hash_table.h>
Index: uspace/lib/libblock/libblock.h
===================================================================
--- uspace/lib/libblock/libblock.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libblock/libblock.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,9 +36,9 @@
 
 #ifndef LIBBLOCK_LIBBLOCK_H_
-#define LIBBLOCK_LIBBLOCK_H_
+#define	LIBBLOCK_LIBBLOCK_H_ 
 
 #include <stdint.h>
 #include "../../srv/vfs/vfs.h"
-#include <fibril_synch.h>
+#include <fibril_sync.h>
 #include <adt/hash_table.h>
 #include <adt/list.h>
Index: uspace/lib/libc/Makefile.build
===================================================================
--- uspace/lib/libc/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -50,5 +50,4 @@
 	generic/as.c \
 	generic/cap.c \
-	generic/clipboard.c \
 	generic/devmap.c \
 	generic/event.c \
@@ -57,5 +56,5 @@
 	generic/string.c \
 	generic/fibril.c \
-	generic/fibril_synch.c \
+	generic/fibril_sync.c \
 	generic/pcb.c \
 	generic/smc.c \
Index: uspace/lib/libc/arch/amd64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/amd64/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/amd64/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -37,8 +37,4 @@
 #ifndef LIBC_amd64_ATOMIC_H_
 #define LIBC_amd64_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val) {
Index: uspace/lib/libc/arch/arm32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/arm32/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/arm32/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -37,50 +37,4 @@
 #define LIBC_arm32_ATOMIC_H_
 
-#define LIBC_ARCH_ATOMIC_H_
-#define CAS 
-
-#include <atomicdflt.h>
-#include <bool.h>
-#include <sys/types.h>
-
-extern uintptr_t *ras_page;
-
-static inline bool cas(atomic_t *val, long ov, long nv)
-{
-	long ret = 0;
-
-	/*
-	 * The following instructions between labels 1 and 2 constitute a
-	 * Restartable Atomic Seqeunce. Should the sequence be non-atomic,
-	 * the kernel will restart it.
-	 */
-	asm volatile (
-		"1:\n"
-		"	adr %[ret], 1b\n"
-		"	str %[ret], %[rp0]\n"
-		"	adr %[ret], 2f\n"
-		"	str %[ret], %[rp1]\n"
-		"	ldr %[ret], %[addr]\n"
-		"	cmp %[ret], %[ov]\n"
-		"	streq %[nv], %[addr]\n"
-		"2:\n"
-		"	moveq %[ret], #1\n"
-		"	movne %[ret], #0\n"
-		: [ret] "+&r" (ret),
-		  [rp0] "=m" (ras_page[0]),
-		  [rp1] "=m" (ras_page[1]),
-		  [addr] "+m" (val->count)
-		: [ov] "r" (ov),
-		  [nv] "r" (nv)
-		: "memory"
-	);
-
-	ras_page[0] = 0;
-	asm volatile ("" ::: "memory");	
-	ras_page[1] = 0xffffffff;
-
-	return (bool) ret;
-}
-
 /** Atomic addition.
  *
@@ -92,31 +46,20 @@
 static inline long atomic_add(atomic_t *val, int i)
 {
-	long ret = 0;
+	int ret;
+	volatile long * mem = &(val->count);
 
-	/*
-	 * The following instructions between labels 1 and 2 constitute a
-	 * Restartable Atomic Seqeunce. Should the sequence be non-atomic,
-	 * the kernel will restart it.
-	 */
 	asm volatile (
-		"1:\n"
-		"	adr %[ret], 1b\n"
-		"	str %[ret], %[rp0]\n"
-		"	adr %[ret], 2f\n"
-		"	str %[ret], %[rp1]\n"
-		"	ldr %[ret], %[addr]\n"
-		"	add %[ret], %[ret], %[imm]\n"
-		"	str %[ret], %[addr]\n"
-		"2:\n"
-		: [ret] "+&r" (ret),
-		  [rp0] "=m" (ras_page[0]),
-		  [rp1] "=m" (ras_page[1]),
-		  [addr] "+m" (val->count)
-		: [imm] "r" (i)
+	"1:\n"
+		"ldr r2, [%1]\n"
+		"add r3, r2, %2\n"
+		"str r3, %0\n"
+		"swp r3, r3, [%1]\n"
+		"cmp r3, r2\n"
+		"bne 1b\n"
+
+		: "=m" (ret)
+		: "r" (mem), "r" (i)
+		: "r3", "r2"
 	);
-
-	ras_page[0] = 0;
-	asm volatile ("" ::: "memory");	
-	ras_page[1] = 0xffffffff;
 
 	return ret;
Index: uspace/lib/libc/arch/arm32/src/entry.s
===================================================================
--- uspace/lib/libc/arch/arm32/src/entry.s	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/arm32/src/entry.s	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,11 +36,6 @@
 #
 # r1 contains the PCB pointer
-# r2 contains the RAS page address
 #
 __entry:
-	# Store the RAS page address into the ras_page variable
-	ldr r0, =ras_page
-	str r2, [r0]
-
 	# Pass pcb_ptr to __main as the first argument (in r0)
 	mov r0, r1
@@ -48,9 +43,2 @@
 
 	bl __exit
-
-.data
-
-.global ras_page
-ras_page:
-	.long 0
-
Index: uspace/lib/libc/arch/arm32/src/syscall.c
===================================================================
--- uspace/lib/libc/arch/arm32/src/syscall.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/arm32/src/syscall.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -60,7 +60,6 @@
 	register sysarg_t __arm_reg_r5 asm("r5") = p6;
 	register sysarg_t __arm_reg_r6 asm("r6") = id;
-	
-	asm volatile (
-		"swi 0"
+
+	asm volatile ( "swi"
 		: "=r" (__arm_reg_r0)
 		: "r" (__arm_reg_r0),
@@ -72,5 +71,5 @@
 		  "r" (__arm_reg_r6)
 	);
-	
+
 	return __arm_reg_r0;
 }
Index: uspace/lib/libc/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/ia32/Makefile.inc	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/ia32/Makefile.inc	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -39,5 +39,4 @@
 	arch/$(UARCH)/src/setjmp.S
 
-GCC_CFLAGS += -march=pentium
 LFLAGS += -N
 
Index: uspace/lib/libc/arch/ia32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia32/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/ia32/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ia32_ATOMIC_H_
 #define LIBC_ia32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val) {
Index: uspace/lib/libc/arch/ia64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ia64/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/ia64/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ia64_ATOMIC_H_
 #define LIBC_ia64_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val)
Index: uspace/lib/libc/arch/mips32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/mips32/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/mips32/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,8 +36,4 @@
 #ifndef LIBC_mips32_ATOMIC_H_
 #define LIBC_mips32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 #define atomic_inc(x)	((void) atomic_add(x, 1))
Index: uspace/lib/libc/arch/ppc32/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/ppc32/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/ppc32/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,8 +35,4 @@
 #ifndef LIBC_ppc32_ATOMIC_H_
 #define LIBC_ppc32_ATOMIC_H_
-
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 
 static inline void atomic_inc(atomic_t *val)
Index: uspace/lib/libc/arch/sparc64/include/atomic.h
===================================================================
--- uspace/lib/libc/arch/sparc64/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/arch/sparc64/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,7 +36,4 @@
 #define LIBC_sparc64_ATOMIC_H_
 
-#define LIBC_ARCH_ATOMIC_H_
-
-#include <atomicdflt.h>
 #include <sys/types.h>
 
Index: uspace/lib/libc/generic/async.c
===================================================================
--- uspace/lib/libc/generic/async.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/generic/async.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -392,18 +392,4 @@
 	/* If nothing in queue, wait until something arrives */
 	while (list_empty(&conn->msg_queue)) {
-		if (conn->close_callid) {
-			/*
-			 * Handle the case when the connection was already
-			 * closed by the client but the server did not notice
-			 * the first IPC_M_PHONE_HUNGUP call and continues to
-			 * call async_get_call_timeout(). Repeat
-			 * IPC_M_PHONE_HUNGUP until the caller notices. 
-			 */
-			memset(call, 0, sizeof(ipc_call_t));
-			IPC_SET_METHOD(*call, IPC_M_PHONE_HUNGUP);
-			futex_up(&async_futex);
-			return conn->close_callid;
-		}
-
 		if (usecs)
 			async_insert_timeout(&conn->wdata);
@@ -542,5 +528,5 @@
 	list_initialize(&conn->msg_queue);
 	conn->callid = callid;
-	conn->close_callid = 0;
+	conn->close_callid = false;
 	
 	if (call)
@@ -1345,97 +1331,4 @@
 }
 
-/** Wrapper for receiving blobs via the async_data_write_*
- *
- * This wrapper only makes it more comfortable to use async_data_write_*
- * functions to receive blobs.
- *
- * @param blob     Pointer to data pointer (which should be later disposed
- *                 by free()). If the operation fails, the pointer is not
- *                 touched.
- * @param max_size Maximum size (in bytes) of the blob to receive. 0 means
- *                 no limit.
- * @param received If not NULL, the size of the received data is stored here.
- *
- * @return Zero on success or a value from @ref errno.h on failure.
- *
- */
-int async_data_blob_receive(char **blob, const size_t max_size, size_t *received)
-{
-	ipc_callid_t callid;
-	size_t size;
-	if (!async_data_write_receive(&callid, &size)) {
-		ipc_answer_0(callid, EINVAL);
-		return EINVAL;
-	}
-	
-	if ((max_size > 0) && (size > max_size)) {
-		ipc_answer_0(callid, EINVAL);
-		return EINVAL;
-	}
-	
-	char *data = (char *) malloc(size);
-	if (data == NULL) {
-		ipc_answer_0(callid, ENOMEM);
-		return ENOMEM;
-	}
-	
-	int rc = async_data_write_finalize(callid, data, size);
-	if (rc != EOK) {
-		free(data);
-		return rc;
-	}
-	
-	*blob = data;
-	if (received != NULL)
-		*received = size;
-	
-	return EOK;
-}
-
-/** Wrapper for receiving strings via the async_data_write_*
- *
- * This wrapper only makes it more comfortable to use async_data_write_*
- * functions to receive strings.
- *
- * @param str      Pointer to string pointer (which should be later disposed
- *                 by free()). If the operation fails, the pointer is not
- *                 touched.
- * @param max_size Maximum size (in bytes) of the string to receive. 0 means
- *                 no limit.
- *
- * @return Zero on success or a value from @ref errno.h on failure.
- *
- */
-int async_data_string_receive(char **str, const size_t max_size)
-{
-	ipc_callid_t callid;
-	size_t size;
-	if (!async_data_write_receive(&callid, &size)) {
-		ipc_answer_0(callid, EINVAL);
-		return EINVAL;
-	}
-	
-	if ((max_size > 0) && (size > max_size)) {
-		ipc_answer_0(callid, EINVAL);
-		return EINVAL;
-	}
-	
-	char *data = (char *) malloc(size + 1);
-	if (data == NULL) {
-		ipc_answer_0(callid, ENOMEM);
-		return ENOMEM;
-	}
-	
-	int rc = async_data_write_finalize(callid, data, size);
-	if (rc != EOK) {
-		free(data);
-		return rc;
-	}
-	
-	data[size] = 0;
-	*str = data;
-	return EOK;
-}
-
 /** @}
  */
Index: uspace/lib/libc/generic/devmap.c
===================================================================
--- uspace/lib/libc/generic/devmap.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ uspace/lib/libc/generic/devmap.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -35,6 +35,4 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
-#include <bool.h>
 
 static int devmap_phone_driver = -1;
@@ -107,5 +105,6 @@
 	aid_t req = async_send_2(phone, DEVMAP_DRIVER_REGISTER, 0, 0, &answer);
 	
-	ipcarg_t retval = async_data_write_start(phone, name, str_size(name));
+	ipcarg_t retval = async_data_write_start(phone, name, str_size(name) + 1);
+	
 	if (retval != EOK) {
 		async_wait_for(req, NULL);
@@ -127,10 +126,9 @@
 /** Register new device.
  *
- * @param namespace Namespace name.
- * @param fqdn      Fully qualified device name.
- * @param handle    Output: Handle to the created instance of device.
+ * @param name   Device name.
+ * @param handle Output: Handle to the created instance of device.
  *
  */
-int devmap_device_register(const char *fqdn, dev_handle_t *handle)
+int devmap_device_register(const char *name, dev_handle_t *handle)
 {
 	int phone = devmap_get_phone(DEVMAP_DRIVER, IPC_FLAG_BLOCKING);
@@ -145,5 +143,6 @@
 	    &answer);
 	
-	ipcarg_t retval = async_data_write_start(phone, fqdn, str_size(fqdn));
+	ipcarg_t retval = async_data_write_start(phone, name, str_size(name) + 1);
+	
 	if (retval != EOK) {
 		async_wait_for(req, NULL);
@@ -168,5 +167,5 @@
 }
 
-int devmap_device_get_handle(const char *fqdn, dev_handle_t *handle, unsigned int flags)
+int devmap_device_get_handle(const char *name, dev_handle_t *handle, unsigned int flags)
 {
 	int phone = devmap_get_phone(DEVMAP_CLIENT, flags);
@@ -181,5 +180,6 @@
 	    &answer);
 	
-	ipcarg_t retval = async_data_write_start(phone, fqdn, str_size(fqdn));
+	ipcarg_t retval = async_data_write_start(phone, name, str_size(name) + 1);
+	
 	if (retval != EOK) {
 		async_wait_for(req, NULL);
@@ -202,55 +202,4 @@
 	
 	return retval;
-}
-
-int devmap_namespace_get_handle(const char *name, dev_handle_t *handle, unsigned int flags)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, flags);
-	
-	if (phone < 0)
-		return phone;
-	
-	async_serialize_start();
-	
-	ipc_call_t answer;
-	aid_t req = async_send_2(phone, DEVMAP_NAMESPACE_GET_HANDLE, flags, 0,
-	    &answer);
-	
-	ipcarg_t retval = async_data_write_start(phone, name, str_size(name));
-	if (retval != EOK) {
-		async_wait_for(req, NULL);
-		async_serialize_end();
-		return retval;
-	}
-	
-	async_wait_for(req, &retval);
-	
-	async_serialize_end();
-	
-	if (retval != EOK) {
-		if (handle != NULL)
-			*handle = (dev_handle_t) -1;
-		return retval;
-	}
-	
-	if (handle != NULL)
-		*handle = (dev_handle_t) IPC_GET_ARG1(answer);
-	
-	return retval;
-}
-
-devmap_handle_type_t devmap_handle_probe(dev_handle_t handle)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
-	
-	if (phone < 0)
-		return phone;
-	
-	ipcarg_t type;
-	int retval = async_req_1_1(phone, DEVMAP_HANDLE_PROBE, handle, &type);
-	if (retval != EOK)
-		return DEV_HANDLE_NONE;
-	
-	return (devmap_handle_type_t) type;
 }
 
@@ -278,5 +227,5 @@
 	
 	ipcarg_t null_id;
-	int retval = async_req_0_1(phone, DEVMAP_NULL_CREATE, &null_id);
+	int retval = async_req_0_1(phone, DEVMAP_DEVICE_NULL_CREATE, &null_id);
 	if (retval != EOK)
 		return -1;
@@ -292,11 +241,16 @@
 		return;
 	
-	async_req_1_0(phone, DEVMAP_NULL_DESTROY, (ipcarg_t) null_id);
-}
-
-static size_t devmap_count_namespaces_internal(int phone)
-{
+	async_req_1_0(phone, DEVMAP_DEVICE_NULL_DESTROY, (ipcarg_t) null_id);
+}
+
+ipcarg_t devmap_device_get_count(void)
+{
+	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
+	
+	if (phone < 0)
+		return 0;
+	
 	ipcarg_t count;
-	int retval = async_req_0_1(phone, DEVMAP_GET_NAMESPACE_COUNT, &count);
+	int retval = async_req_0_1(phone, DEVMAP_DEVICE_GET_COUNT, &count);
 	if (retval != EOK)
 		return 0;
@@ -305,135 +259,31 @@
 }
 
-static size_t devmap_count_devices_internal(int phone, dev_handle_t ns_handle)
-{
-	ipcarg_t count;
-	int retval = async_req_1_1(phone, DEVMAP_GET_DEVICE_COUNT, ns_handle, &count);
+ipcarg_t devmap_device_get_devices(ipcarg_t count, dev_desc_t *data)
+{
+	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
+	
+	if (phone < 0)
+		return 0;
+	
+	async_serialize_start();
+	
+	ipc_call_t answer;
+	aid_t req = async_send_0(phone, DEVMAP_DEVICE_GET_DEVICES, &answer);
+	
+	ipcarg_t retval = async_data_read_start(phone, data, count * sizeof(dev_desc_t));
+	
+	if (retval != EOK) {
+		async_wait_for(req, NULL);
+		async_serialize_end();
+		return 0;
+	}
+	
+	async_wait_for(req, &retval);
+	
+	async_serialize_end();
+	
 	if (retval != EOK)
 		return 0;
 	
-	return count;
-}
-
-size_t devmap_count_namespaces(void)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
-	
-	if (phone < 0)
-		return 0;
-	
-	return devmap_count_namespaces_internal(phone);
-}
-
-size_t devmap_count_devices(dev_handle_t ns_handle)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
-	
-	if (phone < 0)
-		return 0;
-	
-	return devmap_count_devices_internal(phone, ns_handle);
-}
-
-size_t devmap_get_namespaces(dev_desc_t **data)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
-	
-	if (phone < 0)
-		return 0;
-	
-	/* Loop until namespaces read succesful */
-	while (true) {
-		size_t count = devmap_count_namespaces_internal(phone);
-		if (count == 0)
-			return 0;
-		
-		dev_desc_t *devs = (dev_desc_t *) calloc(count, sizeof(dev_desc_t));
-		if (devs == NULL)
-			return 0;
-		
-		async_serialize_start();
-		
-		ipc_call_t answer;
-		aid_t req = async_send_0(phone, DEVMAP_GET_NAMESPACES, &answer);
-		
-		int rc = async_data_read_start(phone, devs, count * sizeof(dev_desc_t));
-		if (rc == EOVERFLOW) {
-			/*
-			 * Number of namespaces has changed since
-			 * the last call of DEVMAP_DEVICE_GET_NAMESPACE_COUNT
-			 */
-			async_serialize_end();
-			free(devs);
-			continue;
-		}
-		
-		if (rc != EOK) {
-			async_wait_for(req, NULL);
-			async_serialize_end();
-			free(devs);
-			return 0;
-		}
-		
-		ipcarg_t retval;
-		async_wait_for(req, &retval);
-		async_serialize_end();
-		
-		if (retval != EOK)
-			return 0;
-		
-		*data = devs;
-		return count;
-	}
-}
-
-size_t devmap_get_devices(dev_handle_t ns_handle, dev_desc_t **data)
-{
-	int phone = devmap_get_phone(DEVMAP_CLIENT, IPC_FLAG_BLOCKING);
-	
-	if (phone < 0)
-		return 0;
-	
-	/* Loop until namespaces read succesful */
-	while (true) {
-		size_t count = devmap_count_devices_internal(phone, ns_handle);
-		if (count == 0)
-			return 0;
-		
-		dev_desc_t *devs = (dev_desc_t *) calloc(count, sizeof(dev_desc_t));
-		if (devs == NULL)
-			return 0;
-		
-		async_serialize_start();
-		
-		ipc_call_t answer;
-		aid_t req = async_send_1(phone, DEVMAP_GET_DEVICES, ns_handle, &answer);
-		
-		int rc = async_data_read_start(phone, devs, count * sizeof(dev_desc_t));
-		if (rc == EOVERFLOW) {
-			/*
-			 * Number of devices has changed since
-			 * the last call of DEVMAP_DEVICE_GET_DEVICE_COUNT
-			 */
-			async_serialize_end();
-			free(devs);
-			continue;
-		}
-		
-		if (rc != EOK) {
-			async_wait_for(req, NULL);
-			async_serialize_end();
-			free(devs);
-			return 0;
-		}
-		
-		ipcarg_t retval;
-		async_wait_for(req, &retval);
-		async_serialize_end();
-		
-		if (retval != EOK)
-			return 0;
-		
-		*data = devs;
-		return count;
-	}
-}
+	return IPC_GET_ARG1(answer);
+}
